
## Set up ESLint
* Install the following VSCode extensions 
  * `ESLint`
  * `Vetur`
  * `Prettier - Code formatter`
* Edit settings.json
  * `CTRL+SHIFT+P` -> `Open Settings (JSON)` -- This will open an editor for `settings.json`.
  * Copy content of `settings.json.example` into the editor.

## Best practices
* To prevent circular dependencies between components:
  * It’s okay to use dispatchEvent for upward communication (i.e. child component to ancestors). This fits with how the JS event model works as it already supports event propagation out of the box.
  * For downward communication, don’t use any sort of event/pub-sub mechanism. Always use Vuejs data binding instead.

## Link to local npm during development
- `cd glib-web-npm`
- `yarn link`
- `cd PROJECT_DIR`
- `yarn link glib-web`
- `bin/webpack-dev-server`

## Publish package to npm
- Bump `version` in `package.json`  
- Run `npm publish`
- Check uploaded version on https://www.npmjs.com i.e. https://www.npmjs.com/package/glib-web
