export default class {
  static saveInitialContent(content) {
    // This differs from window.history.length in that this only counts internal navigation
    this.navigationCount = 0
    // Set initial state so we can go back to it
    window.history.replaceState(this.data(content), '', window.location.href)
  }

  static data(content) {
    return { content: content, navigationCount: this.navigationCount }
  }

  static pushPage(content, url) {
    this.navigationCount++
    window.history.pushState(this.data(content), '', url)
  }

  static restoreOnBackOrForward() {
    const vm = this
    window.onpopstate = event => {
      const data = event.state
      window.vueApp.page = data.content
      vm.navigationCount = data.navigationCount
    }
  }
  
  static updatePage(url = window.location.href) {
    window.history.replaceState(this.data(window.vueApp.page), '', url)
  }
  
  static back() {
    if (this.navigationCount > 0) {
      window.history.back()
    }
    else {
      console.log("Reached beginning of navigation stack")
    }
  }
}

