import { DirectUpload } from "@rails/activestorage"
import Type from "../utils/type"

const MB_SIZE = 1000

export default class Uploader {
  // constructor(input, file, url) {
  //   this.input = input
  //   this.file = file
  //   this.url = url
  //   this.upload = new DirectUpload(this.file, this.url, this)
  // }
  
  constructor(file, url, progress) {
    this.file = file
    this.url = url
    this.progress = progress
    this.upload = new DirectUpload(this.file, this.url, this)
  }

  start(callback) {
    this.progress.value = 0
    // this.dispatch("start")
    this.upload.create((error, blob) => callback(error, blob))
  }

  // dispatchEvent(element, type, eventInit = {}) {
  //   const { disabled } = element
  //   const { bubbles, cancelable, detail } = eventInit
  //   const event = document.createEvent("Event")

  //   event.initEvent(type, bubbles || true, cancelable || true)
  //   event.detail = detail || {}

  //   try {
  //     element.disabled = false
  //     element.dispatchEvent(event)
  //   } finally {
  //     element.disabled = disabled
  //   }

  //   return event
  // }

  // dispatch(name, detail = {}) {
  //   detail.file = this.file
  //   return this.dispatchEvent(this.input, `direct-upload:${name}`, { detail })
  // }

  // Called by DirectUpload
  directUploadWillStoreFileWithXHR(request) {
    request.upload.addEventListener("progress", event => this.directUploadDidProgress(event))
  }

  directUploadDidProgress(event) {
    // const progress = event.loaded / event.total * 100
    // if (progress)
    //   this.dispatch("progress", { progress })
    this.progress.value = event.loaded / event.total * 100
  }
  
  // TODO: Deprecate
  validateFile(spec) {
    if (Type.isString(spec.accepts)) {
      if (spec.accepts) {
        const acceptsRegex = new RegExp(spec.accepts)
  
        if (!acceptsRegex.test(this.file.type)) {
          alert('Invalid file type.')
          return false
        }
      }
  
      if (spec.file_size_limit) {
        if (this.file.size > spec.file_size_limit * MB_SIZE) {
          alert(spec.file_size_limit_alert_text)
          return false
        }
      }
    }
    else {
      return this.validateFileAccordingToRules(spec.accepts)
    }

    return true
  }
  
  validateFileAccordingToRules(spec) {
    if (Type.isObject(spec)) {
      if (spec.fileType) {
        const acceptsRegex = new RegExp(spec.fileType)
        if (!acceptsRegex.test(this.file.type)) {
          alert(spec.fileTypeErrorText || 'Invalid file type')
          return false
        }
      }
  
      if (spec.maxFileSize) {
        if (this.file.size > spec.maxFileSize * MB_SIZE) {
          alert(spec.maxFileSizeErrorText || 'File too big')
          return false
        }
      }
    }

    return true
  }
}
